<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2008/02/28
// Version    : 2.85
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// asm4cmt.php
//
//--------------------------------------------------------------------

require "./".BLOGN_MODDIR."asm4cmt/function.php";

antispam_input_comment($blogn_user, $blogn_post_cid, $blogn_post_cname, $blogn_post_cemail, $blogn_post_curl, $_POST["blogn_cmes"], $blogn_post_set_cookie, $blogn_server_remode_addr, $blogn_server_http_user_agent, $blogn_server_http_referer, $_POST[$tsname]);


function antispam_input_comment($user, $entry_id, $name, $email = "", $url = "", $mes, $set_cookie, $ip, $agent, $referer, $display_time) {

	$submit_time = time();
	if (!$display_time || !preg_match("/^[0-9a-f]{8}$/", $display_time)) {
		$seconds = NULL;
	} else {
		$seconds = $submit_time - hexdec($display_time);
		if ($seconds < 0) $seconds = NULL;
	}
	
	$asm4cmt_errflg = "0";
	$errflg = false;
	$asm4cmt_err = "";
	
	$utf_name = asm4cmt_remove_rn(blogn_mbConv($name, 0, 4));
	if (preg_match("/^(\s)*#/", $utf_name)) $utf_name = "";
	$utf_email = asm4cmt_remove_rn(blogn_mbConv($email, 0, 4));
	$utf_url = asm4cmt_remove_rn(blogn_mbConv($url, 0, 4));
	$utf_mes = blogn_mbConv(rtrim($mes), 0, 4);
	
	$blogn_entry_url = BLOGN_HOMELINK."index.php?e=".$entry_id;

	if (!$entry_id && !is_numeric($entry_id)) {
		$errflg = true;
		exit();
	} elseif (!$utf_name || !$utf_mes) {
		$errflg = true;
	} elseif (!$seconds || $seconds < 16 || $seconds > 259200) {
		$errflg = true;
	} else {
		$logdata = blogn_mod_db_log_load_for_editor($entry_id);
		$diffdays = blogn_date_diff($logdata[1]["date"]);
		if (BLOGN_LIMIT_COMMENT && BLOGN_LIMIT_COMMENT < $diffdays) {
			$errflg = true;
		} else {
			if (strlen($utf_mes) > BLOGN_COMMENT_SIZE && BLOGN_COMMENT_SIZE != 0) $utf_mes = blogn_mbtrim($utf_mes,BLOGN_COMMENT_SIZE);
			if ($user) {
				$comment = blogn_mod_db_comment_load_for_new(1, 0, 10);
			} else {
				$comment = blogn_mod_db_comment_load_for_new(0, 0, 10);
			}

			// 重複投稿チェック
			if ($comment[0]) {
				while (list($key, $val) = each($comment[1])) {
					if ($val["name"] == $utf_name && strip_tags($val["comment"]) == strip_tags( blogn_mod_db_rn2br($utf_mes))) {
						$errflg = true;
						break;
						exit();
					}
				}
			}
		}
	}

	if (file_exists(BLOGN_MODDIR."captcha/viewer.php")) {
		// キャプチャ・チェック
		blogn_mod_captcha_check($captcha_errflg, $info, $link_url, $entry_id);
		if ($captcha_errflg) {
			$errflg = "true";
		}
	}

	if (!$errflg) {
		$inifile = BLOGN_MODDIR."asm4cmt/config.ini";
		$inis = file($inifile);
		list($mode, $language, $urls, $difference, $name_limit, $trip, $autolink, $quote, $mailcmt, $tsname, $cap) = explode(",", $inis[0]);
		list($wt_lang, $wt_href, $wt_bbcode, $wt_atmark, $wt_https, $wt_time, $wt_mail, $wt_urlincmt, $wt_redirect, $wt_ngword, $wt_blip, $wt_proxy, $wt_badref) = explode(",", $inis[1]);

		// 投稿者名から特定の記号を変換
		$array1 = array ("◆","■","▲","▼","●","★","＃");
		$array2 = array ("◇","□","△","▽","○","☆","#");
		$utf_name = str_replace($array1, $array2, $utf_name);

		// キャップ機能
		if ($cap == "capon") {
			if (preg_match("/^(\#|＃)(.+)$/", $utf_email, $email_match)) {
				$cap_list = file(BLOGN_MODDIR."asm4cmt/cap.cgi");
				$cap_count = count($cap_list);
				$i = 0;
				for ($i = 0; $i < $cap_count; $i++) {
					list($cap_pass, $cap_cap) = explode("=", trim($cap_list[$i]));
					if ($email_match[2] == $cap_pass) {
						$utf_name = $cap_cap."★";
						$trip = "";
						break;
					}
				}
				$utf_email = "";
				$cap = "capped";
			}
		} else {
			if (preg_match("/^(\#|＃)(.+)$/", $utf_email)) {
				$utf_email = "";
			}
		}
		// メールに @ が含まれていない場合、空にする（キャップパス漏れ防止）
		$pos = '';
		$pos = strpos($utf_email, "@");
		if ($pos === false) $utf_email = "";
		
		if ($mode <= 3) {
			// 日本語チェック
			if ($wt_lang) {
				if ($language == "engng") {
					if (!preg_match("/[ぁ-んァ-ヶ一-龍]{15}/", $utf_mes)) {
						$asm4cmt_errflg += $wt_lang;
						$asm4cmt_err .= "[非日本語]";
					}
				} elseif ($language == "chnng") {
					if (!preg_match("/[ぁ-んァ-ヶ]{9}/", $utf_mes)) {
						$asm4cmt_errflg += $wt_lang;
						$asm4cmt_err .= "[非日本語]";
					}
				}
			}

			// タイムスタンプチェック
			if ($seconds <= $difference) {
				$asm4cmt_errflg += $wt_time;
				$asm4cmt_err .= "[投稿時間]";
			}

			// コメント内に HREF
			if (preg_match("/href=/i", $utf_mes)) {
				$asm4cmt_errflg += $wt_href;
				$asm4cmt_err .= "[リンク (HREF=)]";
			}
	
			// コメント内に BBCode でリンク
			if (preg_match("/\[url/i", $utf_mes)) {
				$asm4cmt_errflg += $wt_bbcode;
				$asm4cmt_err .= "[リンク (URL=)]";
			}

			// コメント内にメールアドレス
			if (preg_match("/[a-zA-Z0-9_\.\-]+?@[A-Za-z0-9_\.\-]+/", $utf_mes)) {
				$asm4cmt_errflg += $wt_href;
				$asm4cmt_err .= "[@]";
			}

			// http の数をカウント
			$https_count = substr_count(strtolower($utf_mes), "http");
			if ($urls <= $https_count) {
				$asm4cmt_errflg += $wt_https;
				$asm4cmt_err .= "[URL羅列]";
			}

			// メールとURL
			if ($utf_email && $utf_url) {
				$asm4cmt_errflg += $wt_mail;
				$asm4cmt_err .= "[MAIL+URL]";
			}

			// コメントに URL 欄と同じ URL があるかチェック
			if ($utf_url) {
				if (eregi($utf_url, $utf_mes)) {
					$asm4cmt_errflg += $wt_urlincmt;
					$asm4cmt_err .= "[重複URL]";
				}
			}

			// リファラ
			if ($referer != $blogn_entry_url) {
				$asm4cmt_errflg += $wt_badref;
				$asm4cmt_err .= "[リファラ]";
			}
			
			// 使用禁止ワードチェック
			$data = fopen(BLOGN_MODDIR."asm4cmt/ngwd.dat", "r");
			$ng_wd = fgets($data, 2048);
			if (strlen($ng_wd)) {
				$ng_wd = preg_replace("/[,]+$/", "", $ng_wd);
				$ng_wd = explode(",", $ng_wd);
				if (is_array($ng_wd)) {
					foreach ($ng_wd as $deny_wd) {
						if (preg_match("/$deny_wd/i", $utf_mes) || preg_match("/$deny_wd/i", $utf_url) || preg_match("/$deny_wd/i", $utf_name)) {
							$asm4cmt_errflg += $wt_ngword;
							$asm4cmt_err .= "[禁止ワード]";
						}
					}
				}
			}
			fclose($data);

			// リンク先のチェック
			if ($wt_redirect && $utf_url) {
				$page = strip_tags(get_html($utf_url), '<meta>'); //URLからHTMLを取得
				if (!$page) {
					$utf_url ="";
				} else {
					$page = htmlspecialchars($page);
					$page = substr($page, 0, 2000);
					if (preg_match("/Location: http:/i", $page)) {
						$asm4cmt_errflg += $wt_redirect;
						$asm4cmt_err .= "[リダイレクト]";
					} elseif (preg_match("/http-equiv=(&quot;|'){0,1}refresh(&quot;|'){0,1}/i", $page)) {
						$asm4cmt_errflg += $wt_redirect;
						$asm4cmt_err .= "[リダイレクト]";
					}
				}
			}

			// ブラックリストに登録されているかチェック
			preg_match("/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/", $ip, $ips);
			$domain = $ips[4].'.'.$ips[3].'.'.$ips[2].'.'.$ips[1];
			if ($wt_proxy) {
				if (strstr(gethostbyname($domain.'.niku.2ch.net'), "127.0.0")) {
					$asm4cmt_errflg += $wt_proxy;
					$asm4cmt_err .= "[プロキシ]";
				}
			}	
			if ($wt_blip) {
				if (strstr(gethostbyname($domain.'.bsb.spamlookup.net'), "127.0.0")) {
					$asm4cmt_errflg += $wt_blip;
					$asm4cmt_err .= "[IPアドレス]";
				}
			}
		} else {
			$asm4cmt_errflg = "10";
			$asm4cmt_err = "[保留中]";
		}
			
		
		// トリップ機能＋投稿者名文字数制限
		if ($trip == "tripon") {
			if (preg_match("/([^\#]*)\#(.+)/", $utf_name, $match)) {
				$salt = substr($match[2]."H.", 1, 2);
				$salt = preg_replace("/[^\.-z]/", ".", $salt);
				$salt = strtr($salt, "\x3A-\x40\x5B-\x60\x00-\x2D\x7B-\xFF","A-Ga-f.");
				$trip = substr(crypt($match[2], $salt),-10);
				$match[1] = asm4cmt_namelimit($match[1], $name_limit);
				$utf_name = $match[1]."◆".$trip;
			} else {
				$utf_name = asm4cmt_namelimit($utf_name, $name_limit);
			}
		} elseif ($cap != "capped") {
			$pos = "";
			$pos = strpos($utf_name, "#");
			if ($pos === false) {
				$utf_name = asm4cmt_namelimit($utf_name, $name_limit);
			} else {
				preg_match("/([^\#]*)\#(.+)/", $utf_name, $match);
				$utf_name = asm4cmt_namelimit($match[1], $name_limit);
			}
		}

		$utf_mes = blogn_html_tag_convert($utf_mes);
	
		if ($autolink != "nolink") {
			$utf_mes = asm4cmt_autolink($utf_mes, $autolink);
		}

		// 引用
		if ($quote == "quoteon") {
			$message = asm4cmt_quote($utf_mes);
		} else {
			$message = $utf_mes;
		}
	}

	$date = gmdate("YmdHis", time() + BLOGN_TIMEZONE);
	// モードによる分岐処理
	if (!$errflg) {
		switch ($mode) {
			case "1": // Aモード
				antispam_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $message, $ip, $agent, $referer, $seconds, $asm4cmt_errflg);
				if ($asm4cmt_errflg >= 10) {
					$link_url = $blogn_entry_url."#comments";
					$info = 'コメントは保留されました。<br>管理人承認後、公開されます。<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
				} else {
					$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), $message, $ip, $agent);
				}
				break;

			case "2": // Bモード
				if ($asm4cmt_errflg >= 10) {
					antispam_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $message, $ip, $agent, $referer, $seconds, $asm4cmt_errflg);
					$link_url = $blogn_entry_url."#comments";
					$info = 'コメントは保留されました。<br>管理人承認後、公開されます。<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
				} else {
					$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), $message, $ip, $agent);
				}
				break;

			case "3": // Dモード
				if ($asm4cmt_errflg >= 10) {
					$link_url = $blogn_entry_url."#comments";
					$info = 'コメント投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
				} else {
					$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), $message, $ip, $agent);
				}
				break;

			case "4": // Cモード
				antispam_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $message, $ip, $agent, $referer, $seconds, $asm4cmt_errflg);
				$link_url = $blogn_entry_url."#comments";
				$info = 'コメントは保留されました。<br>管理人承認後、公開されます。<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
				break;

			default: // テストモード
				$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), $message, $ip, $agent);
				antispam_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $utf_mes, $ip, $agent, $referer, $seconds, $asm4cmt_errflg);
				break;
		}
 	} else {
		$link_url = $blogn_entry_url."#comments";
		$info = 'コメント投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
	}

	if ($error[0]) {
		$link_url = $blogn_entry_url."#cmt".$error[2];
		$info = 'コメントを投稿しました。<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
		$userlist = blogn_mod_db_user_load();

		$logdata = blogn_mod_db_log_load_for_editor($entry_id);
		$sub = "コメントを受信しました";
		$sub = blogn_mbConv($sub, 4, 3);
		$sub = "=?iso-2022-jp?B?".base64_encode($sub)."?="; 
		$mes = "件名:".$logdata[1]["title"]."\n"; 
		$mes .= "投稿者名:".$utf_name."\n"; 
		$mes .= "URL:".$blogn_entry_url."#cmt".$error[2]."\n"; 
		$mes .= "※このメールアドレスには返信しないでください。\n\n";
		if ($mailcmt == "comment") {
			$utf_mes = str_replace("<br />", "\n", $utf_mes);
			$mes .= blogn_html_tag_restore($utf_mes);
		}
		$mes = blogn_mbConv($mes, 4, 3); 
		$from = BLOGN_SITENAME; 
		$from = blogn_mbConv($from, 4, 3); 
		$from = "=?iso-2022-jp?B?".base64_encode($from)."?="; 
		$from = "From: $from <blognplus@localhost>\nContent-Type: text/plain; charset=\"iso-2022-jp\""; 

		while (list($key, $val) = each($userlist)) {
			if ($val["information_comment"]) @mail($val["information_mail_address"], $sub, $mes, $from); 
		}
	}

	$errdata = '
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<meta http-equiv="refresh"content="2;URL='.$link_url.'">
<meta http-equiv=content-type content="text/html; charset='.$charset.'">
</head>
<body>
<div align="center">
<div style="text-align:center;border:1px solid;width:400px;">'.$info.'</div>
</div>
</body>
</html>';

	if (BLOGN_CHARSET == 0 || BLOGN_MOBILE_KEY == 1) {
		$charset = "Shift_JIS";
		$outkey = 2;
	}elseif (BLOGN_CHARSET == 1) {
		$charset = "EUC-JP";
		$outkey = 1;
	}elseif (BLOGN_CHARSET == 2) {
		$charset = "UTF-8";
		$outkey = 4;
	}

	if ($set_cookie == "on") {
		setcookie("name", blogn_mbConv($name, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("email", blogn_mbConv($email, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("url", blogn_mbConv($url, 0, 4), time() + BLOGN_TIMEZONE + 604800);
	}

	header("Content-Type: text/html; charset=$charset");
	if ($outkey != 4) $errdata = blogn_mbConv($errdata, 4, $outkey);
	if ($outkey == 2) $errdata = blogn_magic_quotes($errdata);
	echo $errdata;
	exit;
}

/* ----- ログ書き込み ----- */
function antispam_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $utf_mes, $ip, $agent, $referer, $seconds, $asm4cmt_errflg) {
	$asm4cmt_file = BLOGN_MODDIR."asm4cmt/rejected.log";
	$fp = fopen("$asm4cmt_file", "a+");
	flock($fp, LOCK_EX);
	$asm4cmt_data = $entry_id.','.$asm4cmt_err.','.$date.','.asm4cmt_format_data($utf_name).','.asm4cmt_format_data($utf_email).','.blogn_html_tag_convert($utf_url).','.blogn_mod_db_comma_change(blogn_mod_db_rn2br($utf_mes)).','.$ip.','.asm4cmt_format_log($agent).','.asm4cmt_format_log($referer).','.$seconds.','.$asm4cmt_errflg."\n";
	fwrite($fp, $asm4cmt_data);
	flock($fp, LOCK_UN);
	fclose($fp);
}

?>
